# mypy-boto3-athena

[![PyPI - mypy-boto3-athena](https://img.shields.io/pypi/v/mypy-boto3-athena.svg?color=blue)](https://pypi.org/project/mypy-boto3-athena)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-athena.svg?color=blue)](https://pypi.org/project/mypy-boto3-athena)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.Athena 1.14.7](https://boto3.amazonaws.com/v1/documentation/api/1.14.7/reference/services/athena.html#Athena) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Athena` service.

```bash
python -m pip install boto3-stubs[athena]
```

## How to use

### Client annotations

`AthenaClient` provides annotations for `boto3.client("athena")`.

```python
import boto3

from mypy_boto3_athena import AthenaClient
from mypy_boto3_athena.paginator import (
    GetQueryResultsPaginator,
    ListDatabasesPaginator,
    ListDataCatalogsPaginator,
    ListNamedQueriesPaginator,
    ListQueryExecutionsPaginator,
    ListTableMetadataPaginator,
    ListTagsForResourcePaginator,
)
from mypy_boto3_athena.type_defs import ColumnInfoTypeDef, ...

client: AthenaClient = boto3.client("athena")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AthenaClient = session.client("athena")
```

### Paginators annotations

`mypy_boto3_athena.paginator` module contains type annotations for all paginators.

```python

client: AthenaClient = boto3.client("athena")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_query_results_paginator: GetQueryResultsPaginator = client.get_paginator("get_query_results")
list_data_catalogs_paginator: ListDataCatalogsPaginator = client.get_paginator("list_data_catalogs")
list_databases_paginator: ListDatabasesPaginator = client.get_paginator("list_databases")
list_named_queries_paginator: ListNamedQueriesPaginator = client.get_paginator("list_named_queries")
list_query_executions_paginator: ListQueryExecutionsPaginator = client.get_paginator("list_query_executions")
list_table_metadata_paginator: ListTableMetadataPaginator = client.get_paginator("list_table_metadata")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```







### Typed dictionations

`mypy_boto3_athena.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> ColumnInfoTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_athena` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("athena")

session_client = boto3.Session().client("athena")
```
